<template>
	<div :class="!hasHeader ? 'no-header' : ''" class="text-base">
		<GlobalHeader v-if="$route.path !== '/D2C/checkout/' && $route.path !== '/D2C/checkout'" ref="header" />
		<main id="maincontent">
				<div
				v-if="false && SERVICE_ERROR_MESSAGE.message"
				role="alert"
				class="py-2 text-base leading-6 text-center text-black rounded-md bg-error-10 font-primary-font-light flex w-full items-center"
			>
				<div class="grid w-full">
					<p class="contents text-center ml-auto" >{{SERVICE_ERROR_MESSAGE.message}}</p>
					<p v-if="SERVICE_ERROR_MESSAGE.data" class="underline font-bold cursor-pointer ml-1" @click="showPayload=!showPayload">{{showPayload ? 'hide payload' : 'show payload'}} </p>
					<p v-if="showPayload" class="contents text-center ml-auto" >{{SERVICE_ERROR_MESSAGE.data}}</p>
				</div>
				<p
					tabindex="0"
					class="icon-close ml-auto mk-error-close mr-4 text-xs cursor-pointer"
					@keypress.enter="$store.commit('USER_STORE/SET_SERVICE_ERROR', '')"
					@click="$store.commit('USER_STORE/SET_SERVICE_ERROR', '')"
				></p>
				</div>
			<nuxt />
		</main>
		<GlobalChatWidgetZendesk v-if="!$route.path.includes('/checkout')" />
	</div>
</template>

<script>
import GlobalHeader from '@components/global-header';
import { mapState, mapGetters } from 'vuex';
import scrollToHash from '@/utils/scroll-to-hash';
import matchesPath from '@/utils/matches-path';
const GlobalChatWidgetZendesk = () => import('@components/global-chat-widget-zendesk');

let clientPerf = null;

export default {
	name: 'AuroraLayout',
	components: {
		GlobalHeader,
		GlobalChatWidgetZendesk,
	},
	provide() {
		return { openPromoModal: this.openPromoModal, openCart: this.openCart, getHeaderHeight: this.getHeaderHeight };
	},
	data() {
		return {
			tabhandler: '',
			mouseClick: '',
			showPayload:false
		};
	},

	head() {
		const script = [];
		const style = [];
		const __dangerouslyDisableSanitizersByTagID = {};
		const { query, path } = this.$route;
		const {
			enabled: afEnabled,
			onlyOnSpecifiedPaths: afOnlyOnSpecifiedPaths,
			specifiedPaths: afPaths,
		} = this.antiFlicker;

		const getPerf = () => (query.perf && query.perf.split(',')) || [];
		if (process.client && !clientPerf) clientPerf = getPerf();
		const perf = clientPerf || getPerf();

		const shouldUseAntiFlicker = () =>
			!perf.includes('no-anti-flicker') && afEnabled && (!afOnlyOnSpecifiedPaths || matchesPath(path, afPaths));

		if (!(perf.includes('no-tealium') || perf.includes('no-tealium-sync'))) {
			const tealiumSyncUrl = this.$config.tealium.syncUrl;
			if (tealiumSyncUrl) {
				script.push({ hid: 'tealium-sync', type: 'text/javascript', src: tealiumSyncUrl });
			}
		}
		if (process.server && shouldUseAntiFlicker()) {
			script.push({
				hid: 'anti-flicker-script',
				type: 'text/javascript',
				innerHTML: `(function(a,s,y,n,c,h,i,d,e){s.className+=" "+y;h.start=1*new Date;h.end=i=function(){s.className=s.className.replace(RegExp(" ?"+y),"")};(a[n]=a[n]||[]).hide=h;setTimeout(function(){i();h.end=null},c);h.timeout=c})(window,document.documentElement,"async-hide","dataLayer",4E3,{"GTM-TGRHXPH":true});`,
			});
			__dangerouslyDisableSanitizersByTagID['anti-flicker-script'] = ['innerHTML'];
			style.push({
				hid: 'anti-flicker-styles',
				cssText: `.async-hide {opacity: 0 !important}`,
				type: 'text/css',
			});
		}

		if ((process.server && process.env.SENTRY_RELEASE) || (process.client && window.SENTRY_RELEASE)) {
			const release = process.server ? process.env.SENTRY_RELEASE : window.SENTRY_RELEASE.id;
			script.push({
				hid: 'sentry-release',
				type: 'text/javascript',
				innerHTML: `window.SENTRY_RELEASE={id:'${release || ''}'};`,
			});
			__dangerouslyDisableSanitizersByTagID['sentry-release'] = ['innerHTML'];
		}

		return {
			titleTemplate: (titleChunk) => (titleChunk ? `Molekule | ${titleChunk}` : 'Molekule'),
			script,
			__dangerouslyDisableSanitizersByTagID,
			style,
		};
	},

	computed: {
		...mapState({
			promoModals: (state) => state.globalData.promoModals.filter((modal) => !modal.disableModal),
			antiFlicker: (state) => state.globalData.antiFlicker,
		}),
		...mapGetters('magento', ['cart']),
		...mapState('USER_STORE',['SERVICE_ERROR_MESSAGE']),
		hasHeader() {
			return this.$route.path !== '/D2C/checkout/';
		},
	},

	watch: {
		$route: {
			immediate: true,
			handler: 'addToCartBasedOnRoute',
		},
	},

	mounted() {
		scrollToHash(this.$route.hash, { animate: false });
		this.tabhandler = function (e) {
			if (e.keyCode === 9) {
				document.body.classList.add('tab-key-press');
				window.removeEventListener('keyup', this.tabhandler);
			}
		};
		this.mouseClick = function (e) {
			document.body.classList.remove('tab-key-press');
			window.removeEventListener('click', this.mouseClick);
		};
		window.addEventListener('keyup', this.tabhandler);
		window.addEventListener('click', this.mouseClick);
	},

	methods: {
		openPromoModal(stringToAppendToAction) {
			this.$refs.promoModal0[0].open(stringToAppendToAction);
		},

		openCart() {
			this.$refs.header.openCart();
		},

		getHeaderHeight() {
			return this.$refs.header.getHeaderHeight();
		},

		async addToCartBasedOnRoute() {
			if (process.server) return;

			const getExpirationDate = (hours) => {
				const today = new Date();
				return today.setTime(today.getTime() + (hours || 24) * 60 * 60 * 1000);
			};

			const { atc: skus, 'atc-timing': atcLinkTiming } = this.$route.query;
			if (skus) {
				const { products } = this.$store.state.magento;
				const { isUSWebsite } = this.$store.state;
				let addToCartSkus = [];
				skus.split(',').forEach((skuRaw) => {
					let sku = (skuRaw || '').trim();
					const location = sku.slice(0, 2);
					const hasLocation = sku.startsWith('US:') || sku.startsWith('CA:');
					if (hasLocation) {
						if ((isUSWebsite && location !== 'US') || (!isUSWebsite && location === 'US')) return null;
						sku = sku.slice(3);
					}

					let quantity = sku.slice(-1);
					const hasQuantity = /\*\d+$/.test(sku);
					if (hasQuantity) {
						sku = sku.slice(0, -2);
					} else {
						quantity = 1;
					}

					if (products[sku] && sku) {
						for (let i = 0; i < quantity; i++) {
							addToCartSkus.push(sku);
						}
					}
				});

				addToCartSkus = addToCartSkus
					.filter(Boolean)
					.reduce(
						(obj, sku) => {
							obj[0][sku] = (obj[0][sku] || 0) + 1;
							return obj;
						},
						[{}]
					)
					.map((obj) => Object.entries(obj).map(([sku, qty]) => ({ sku, qty })))[0];

				if (addToCartSkus.length) {
					try {
						await this.$store.state.magento.initialFetchCartPromise;
						const areItemsInCart =
							this.cart &&
							this.cart.items &&
							addToCartSkus.length === this.cart.items.length &&
							addToCartSkus.every(({ sku, qty }) =>
								this.cart.items.some((item) => item.sku === sku && item.qty === qty)
							);

						if (!areItemsInCart) {
							await this.$store.dispatch('magento/CLEAR_CART');
							await this.$store.dispatch('magento/ADD_TO_CART', { items: addToCartSkus });

							// TODO: Fix Safari issue without using setTimeout
							this.$nextTick(() => setTimeout(() => this.openCart(), 1500));

							localStorage.setItem(
								'atc_link_timing',
								JSON.stringify({
									skus: addToCartSkus,
									cartUpdatedAt: this.cart.updatedAt,
									expirationDate: getExpirationDate(Number(atcLinkTiming)),
								})
							);
						} else if (areItemsInCart) {
							const currentAtcLinkTiming = localStorage.getItem('atc_link_timing');

							if (currentAtcLinkTiming) {
								localStorage.setItem(
									'atc_link_timing',
									JSON.stringify({
										skus: addToCartSkus,
										cartUpdatedAt: this.cart.updatedAt,
										expirationDate: getExpirationDate(Number(atcLinkTiming)),
									})
								);
							}
						}
					} catch (e) {
						// eslint-disable-next-line no-console
						console.error(e);
						this.$sentry.captureException(e);
					}
				}
			}
		},
	},
};
</script>

<style lang="scss">
@import './app.scss';
@import './app_aurora.scss';
</style>
<style lang="postcss">
	.icon-close.mk-error-close:before{
		color: #000;
	}
</style>
